<?php

namespace testModel;

use PHPUnit\Framework\TestCase;
use Model\ModelAdmin;
use Exception;

class ModelAdminTest extends TestCase
{
    public function testConstructor()
    {
        $model = new ModelAdmin();
        $this->assertInstanceOf(ModelAdmin::class, $model);
    }

    public function testAddQuestionInvalidType()
    {
        $this->expectException(Exception::class);
        $this->expectExceptionMessage("Type de question invalide");
        $_POST['type']="JeSuisUnTypeInvalideDePlusDe50CaracteresEtJeSuisTropLongPourEtreUnTypeDeQuestionValide";
        $_POST['question']="Suis-je une question valide ?";
        $model = (new ModelAdmin())->addQuestion();
    }

    public function testDeleteQuestionInvalidType()
    {
        $this->expectException(Exception::class);
        $this->expectExceptionMessage("Type de question invalide");
        $_POST['type']="JeSuisUnTypeInvalideDePlusDe50CaracteresEtJeSuisTropLongPourEtreUnTypeDeQuestionValide";
        $_POST['question']="Suis-je une question valide ?";
        $model = (new ModelAdmin())->deleteQuestion();
    }

    public function  testAddResponseInvalidCategories()
    {
        $this->expectException(Exception::class);
        $this->expectExceptionMessage('Categories invalides');
        $_POST['categories']=['JeSuisUneCategorieInvalideDePlusDe50CaracteresEtJeSuisTropLonguePourEtreUneCategorieValide'];
        $_POST['response']="Suis-je une réponse valide ?";
        $model = (new ModelAdmin())->addResponse();
    }

    public function  testAddKeywordInvalidKeyword()
    {
        $this->expectException(Exception::class);
        $this->expectExceptionMessage('Mot clé invalide');
        $_POST['keyword']="JeSuisUnMotCleInvalideDePlusDe50CaracteresEtJeSuisTropLonguePourEtreUnMotCleValide";
        $model = (new ModelAdmin())->addKeyword();
    }

    public function testGetCategories()
    {
        $categories = (new ModelAdmin())->getCategories();
        $this->assertIsArray($categories);
    }

    public function testGetQuestions()
    {
        $questions = (new ModelAdmin())->getQuestions();
        $this->assertIsArray($questions);
    }

    public function testGetResponsesCandidate()
    {
        $responses = (new ModelAdmin())->getResponsesCandidate();
        $this->assertIsArray($responses);
    }
}